// D import file generated from 'derelict/devil/iltypes.d'
module derelict.devil.iltypes;
alias uint ILenum;
alias ubyte ILboolean;
alias uint ILbitfield;
alias byte ILbyte;
alias short ILshort;
alias int ILint;
alias int ILsizei;
alias ubyte ILubyte;
alias ushort ILushort;
alias uint ILuint;
alias float ILfloat;
alias float ILclampf;
alias double ILdouble;
alias double ILclampd;
alias void ILvoid;
version (DerelictIL_Unicode)
{
    alias wchar ILchar;
    alias wchar* ILstring;
    version (D_Version2)
{
    mixin("alias const(wchar)* ILconst_string;");
}
else
{
    alias ILstring ILconst_string;
}
}
else
{
    alias char ILchar;
    alias char* ILstring;
    version (D_Version2)
{
    mixin("alias const(char)* ILconst_string;");
}
else
{
    alias ILstring ILconst_string;
}
}
enum : ILboolean
{
IL_FALSE = 0,
IL_TRUE = 1,
}
enum : ILenum
{
IL_COLOUR_INDEX = 6400,
IL_COLOR_INDEX = 6400,
IL_RGB = 6407,
IL_RGBA = 6408,
IL_BGR = 32992,
IL_BGRA = 32993,
IL_LUMINANCE = 6409,
IL_LUMINANCE_ALPHA = 6410,
IL_BYTE = 5120,
IL_UNSIGNED_BYTE = 5121,
IL_SHORT = 5122,
IL_UNSIGNED_SHORT = 5123,
IL_INT = 5124,
IL_UNSIGNED_INT = 5125,
IL_FLOAT = 5126,
IL_DOUBLE = 5130,
IL_HALF = 5131,
IL_VENDOR = 7936,
IL_LOAD_EXT = 7937,
IL_SAVE_EXT = 7938,
IL_VERSION_1_7_3 = 1,
IL_VERSION = 173,
IL_ORIGIN_BIT = 1,
IL_FILE_BIT = 2,
IL_PAL_BIT = 4,
IL_FORMAT_BIT = 8,
IL_TYPE_BIT = 16,
IL_COMPRESS_BIT = 32,
IL_LOADFAIL_BIT = 64,
IL_FORMAT_SPECIFIC_BIT = 128,
IL_ALL_ATTRIB_BITS = 1048575,
IL_PAL_NONE = 1024,
IL_PAL_RGB24 = 1025,
IL_PAL_RGB32 = 1026,
IL_PAL_RGBA32 = 1027,
IL_PAL_BGR24 = 1028,
IL_PAL_BGR32 = 1029,
IL_PAL_BGRA32 = 1030,
IL_TYPE_UNKNOWN = 0,
IL_BMP = 1056,
IL_CUT = 1057,
IL_DOOM = 1058,
IL_DOOM_FLAT = 1059,
IL_ICO = 1060,
IL_JPG = 1061,
IL_JFIF = 1061,
IL_LBM = 1062,
IL_PCD = 1063,
IL_PCX = 1064,
IL_PIC = 1065,
IL_PNG = 1066,
IL_PNM = 1067,
IL_SGI = 1068,
IL_TGA = 1069,
IL_TIF = 1070,
IL_CHEAD = 1071,
IL_RAW = 1072,
IL_MDL = 1073,
IL_WAL = 1074,
IL_LIF = 1076,
IL_MNG = 1077,
IL_JNG = 1077,
IL_GIF = 1078,
IL_DDS = 1079,
IL_DCX = 1080,
IL_PSD = 1081,
IL_EXIF = 1082,
IL_PSP = 1083,
IL_PIX = 1084,
IL_PXR = 1085,
IL_XPM = 1086,
IL_HDR = 1087,
IL_ICNS = 1088,
IL_JP2 = 1089,
IL_EXR = 1090,
IL_WDP = 1091,
IL_JASC_PAL = 1141,
IL_NO_ERROR = 0,
IL_INVALID_ENUM = 1281,
IL_OUT_OF_MEMORY = 1282,
IL_FORMAT_NOT_SUPPORTED = 1283,
IL_INTERNAL_ERROR = 1284,
IL_INVALID_VALUE = 1285,
IL_ILLEGAL_OPERATION = 1286,
IL_ILLEGAL_FILE_VALUE = 1287,
IL_INVALID_FILE_HEADER = 1288,
IL_INVALID_PARAM = 1289,
IL_COULD_NOT_OPEN_FILE = 1290,
IL_INVALID_EXTENSION = 1291,
IL_FILE_ALREADY_EXISTS = 1292,
IL_OUT_FORMAT_SAME = 1293,
IL_STACK_OVERFLOW = 1294,
IL_STACK_UNDERFLOW = 1295,
IL_INVALID_CONVERSION = 1296,
IL_BAD_DIMENSIONS = 1297,
IL_FILE_READ_ERROR = 1298,
IL_FILE_WRITE_ERROR = 1298,
IL_LIB_GIF_ERROR = 1505,
IL_LIB_JPEG_ERROR = 1506,
IL_LIB_PNG_ERROR = 1507,
IL_LIB_TIFF_ERROR = 1508,
IL_LIB_MNG_ERROR = 1509,
IL_LIB_JP2_ERROR = 1510,
IL_UNKNOWN_ERROR = 1535,
IL_ORIGIN_SET = 1536,
IL_ORIGIN_LOWER_LEFT = 1537,
IL_ORIGIN_UPPER_LEFT = 1538,
IL_ORIGIN_MODE = 1539,
IL_FORMAT_SET = 1552,
IL_FORMAT_MODE = 1553,
IL_TYPE_SET = 1554,
IL_TYPE_MODE = 1555,
IL_FILE_OVERWRITE = 1568,
IL_FILE_MODE = 1569,
IL_CONV_PAL = 1584,
IL_DEFAULT_ON_FAIL = 1586,
IL_USE_KEY_COLOUR = 1589,
IL_USE_KEY_COLOR = 1589,
IL_SAVE_INTERLACED = 1593,
IL_INTERLACE_MODE = 1594,
IL_QUANTIZATION_MODE = 1600,
IL_WU_QUANT = 1601,
IL_NEU_QUANT = 1602,
IL_NEU_QUANT_SAMPLE = 1603,
IL_MAX_QUANT_INDEXS = 1604,
IL_FASTEST = 1632,
IL_LESS_MEM = 1633,
IL_DONT_CARE = 1634,
IL_MEM_SPEED_HINT = 1637,
IL_USE_COMPRESSION = 1638,
IL_NO_COMPRESSION = 1639,
IL_COMPRESSION_HINT = 1640,
IL_SUB_NEXT = 1664,
IL_SUB_MIPMAP = 1665,
IL_SUB_LAYER = 1666,
IL_COMPRESS_MODE = 1792,
IL_COMPRESS_NONE = 1793,
IL_COMPRESS_RLE = 1794,
IL_COMPRESS_LZO = 1795,
IL_COMPRESS_ZLIB = 1796,
IL_TGA_CREATE_STAMP = 1808,
IL_JPG_QUALITY = 1809,
IL_PNG_INTERLACE = 1810,
IL_TGA_RLE = 1811,
IL_BMP_RLE = 1812,
IL_SGI_RLE = 1813,
IL_TGA_ID_STRING = 1815,
IL_TGA_AUTHNAME_STRING = 1816,
IL_TGA_AUTHCOMMENT_STRING = 1817,
IL_PNG_AUTHNAME_STRING = 1818,
IL_PNG_TITLE_STRING = 1819,
IL_PNG_DESCRIPTION_STRING = 1820,
IL_TIF_DESCRIPTION_STRING = 1821,
IL_TIF_HOSTCOMPUTER_STRING = 1822,
IL_TIF_DOCUMENTNAME_STRING = 1823,
IL_TIF_AUTHNAME_STRING = 1824,
IL_JPG_SAVE_FORMAT = 1825,
IL_CHEAD_HEADER_STRING = 1826,
IL_PCD_PICNUM = 1827,
IL_PNG_ALPHA_INDEX = 1828,
IL_DXTC_FORMAT = 1797,
IL_DXT1 = 1798,
IL_DXT2 = 1799,
IL_DXT3 = 1800,
IL_DXT4 = 1801,
IL_DXT5 = 1802,
IL_DXT_NO_COMP = 1803,
IL_KEEP_DXTC_DATA = 1804,
IL_DXTC_DATA_FORMAT = 1805,
IL_3DC = 1806,
IL_RXGB = 1807,
IL_ATI1N = 1808,
IL_CUBEMAP_POSITIVEX = 1024,
IL_CUBEMAP_NEGATIVEX = 2048,
IL_CUBEMAP_POSITIVEY = 4096,
IL_CUBEMAP_NEGATIVEY = 8192,
IL_CUBEMAP_POSITIVEZ = 16384,
IL_CUBEMAP_NEGATIVEZ = 32768,
IL_VERSION_NUM = 3554,
IL_IMAGE_WIDTH = 3556,
IL_IMAGE_HEIGHT = 3557,
IL_IMAGE_DEPTH = 3558,
IL_IMAGE_SIZE_OF_DATA = 3559,
IL_IMAGE_BPP = 3560,
IL_IMAGE_BYTES_PER_PIXEL = 3560,
IL_IMAGE_BITS_PER_PIXEL = 3561,
IL_IMAGE_FORMAT = 3562,
IL_IMAGE_TYPE = 3563,
IL_PALETTE_TYPE = 3564,
IL_PALETTE_SIZE = 3565,
IL_PALETTE_BPP = 3566,
IL_PALETTE_NUM_COLS = 3567,
IL_PALETTE_BASE_TYPE = 3568,
IL_NUM_IMAGES = 3569,
IL_NUM_MIPMAPS = 3570,
IL_NUM_LAYERS = 3571,
IL_ACTIVE_IMAGE = 3572,
IL_ACTIVE_MIPMAP = 3573,
IL_ACTIVE_LAYER = 3574,
IL_CUR_IMAGE = 3575,
IL_IMAGE_DURATION = 3576,
IL_IMAGE_PLANESIZE = 3577,
IL_IMAGE_BPC = 3578,
IL_IMAGE_OFFX = 3579,
IL_IMAGE_OFFY = 3580,
IL_IMAGE_CUBEFLAGS = 3581,
IL_IMAGE_ORIGIN = 3582,
IL_IMAGE_CHANNELS = 3583,
}
enum : ILint
{
IL_SEEK_SET = 0,
IL_SEEK_CUR = 1,
IL_SEEK_END = 2,
IL_EOF = 1,
}
alias void* ILHANDLE;
extern (C) 
{
    alias ILvoid function(ILHANDLE) fCloseRProc;
    alias ILboolean function(ILHANDLE) fEofProc;
    alias ILint function(ILHANDLE) fGetcProc;
    alias ILHANDLE function(ILconst_string) fOpenRProc;
    alias ILint function(void*, ILuint, ILuint, ILHANDLE) fReadProc;
    alias ILint function(ILHANDLE, ILint, ILint) fSeekRProc;
    alias ILint function(ILHANDLE) fTellRProc;
    alias ILvoid function(ILHANDLE) fCloseWProc;
    alias ILHANDLE function(ILconst_string) fOpenWProc;
    alias ILint function(ILubyte, ILHANDLE) fPutcProc;
    alias ILint function(ILHANDLE, ILint, ILint) fSeekWProc;
    alias ILint function(ILHANDLE) fTellWProc;
    alias ILint function(in void*, ILuint, ILuint, ILHANDLE) fWriteProc;
    alias ILvoid* function(ILuint) mAlloc;
    alias ILvoid function(in ILvoid*) mFree;
    alias ILenum function(ILconst_string) IL_LOADPROC;
    alias ILenum function(ILconst_string) IL_SAVEPROC;
}
